# Bad Cheesr

Welkom bij Bad-Cheesr, een bewust kwetsbare webapplicatie bedoeld om te leren code reviewen met het oog op software veiligheid aan de hand van de [NCSC Beveiligingsrichtlijn](https://www.ncsc.nl/dienstverlening/expertise-advies/kennisdeling/whitepapers/ict-beveiligingsrichtlijnen-voor-webapplicaties.html) voor Webapplicaties.

Benodigd:
* Maven 3+, Java 7+, IDE
* Browser met Modify Headers plugin. 
* Deze bron code.
* De PDF met workshop instructies.

Hieronder staat de korte samenvatting van de workshop, de volledige instructies staan in de PDF. 

## NCSC Beveiligingsrichtlijn voor Webapplicaties

In de richtlijn wordt ingegaan op punten die van belang zijn tijdens ontwikkeling. Een aantal daarvan zijn door het doen van code reviews te ondervangen:

* B3-1 : U/WA.03.04    : Controle van de Invoer (parameters, urls, headers, files etc)
* B3-2 : U/PW.02.02    : Gebruiker is Geauthenticeert en heeft de juiste Authorisaties.
* B3-3 : U/WA.03.03    : Normalisatie van de invoer.
* B3-4 : U/WA.04.01    :  De uitvoer wordt gecodeerd.
* B3-5 : U/WA.07.01/02 : Database queries gebruiken geparameteriseerde queries.
* B3-6 : U/WA.03.01    : Alle data wordt (ook) op de server gevalideerd.
* B3-7 : U/WA.03.02    : Geen Dynamische includes.
 
De overige punten zijn beter vast te stellen door het uit te proberen:

* B3-8 : U/PW.02.04 : Alleen noodzakelijke Headers.
* B3-9 : U/PW.02.05 : Minimale informatie in de Headers.
* B3-10: U/PW.02.06 : Minimale informatie in foutmeldingen.
* B3-11: U/WA.06.01 : Geen commentaar in de uitvoer.
* B3-12: U/PW.02.03 : Alleen noodzakelijke HTTP methoden.
* B3-13: U/PW.03.02 : Geen directory listings
* B3-14: C.05.01    : (Geautomatiseerde) Code Reviews
* B3-15: C.05.02    : Geautomatiseerde Security Scans
* B3-16: U/PW.03.03 : Http Only / Secure sessie cookie.

## Business Logica  

* De applicatie is een webshop voor kaas. Gebruikers moeten kaas in hun mandje kunnen stoppen en die bestellen.  
* Een gebruiker kan een coupon code hebben waarbij hij extra korting krijgt.
* Het product 'Secret Cheese' dat in de database zit mag nooit besteld kunnen worden (de geheime kaassaus wordt ervan gemaakt).
* De /orders pagina mag alleen geopend worden wanneer de gebruiker de Role: ADMIN header op zijn request heeft.
  (De applicatie maakt gebruik van een gecentraliseerde authenticatie service die de rollen op het request zet).
* Vanuit de /orders pagina kunnen bestellingen afgehandeld worden.
* Alreeds afgehandelde bestellingen mogen niet in de order lijst voorkomen.
* Het systeem heeft een kopelling met Zap-Financials via de ftp-folder.

## Opdracht

Review de code, vindt de kwetsbaarheden en toon ze aan. De volgende fouten zitten minimaal 1 keer in de applicatie:

* Niet Geparametriseerde Queries     
* Niet Escapede Uitvoer    
* Dynamische Includes  
* Foutieve Normalisatie van de Invoer      
* Geen Controle van de Invoer 
* Kapotte Authenticatie/Authorisatie          
* Ontbrekende Serverside validatie
* Xml eXternal Entity processing, file inclusion
* Denial of Service via reguliere expressie   

De volgende zaken, niet direct te vinden via een review zitten er ook in. Kijk of je ze gereproduceerd krijgt:

* Te informatieve Headers          
* Uitgebreide Error details     
* Onthullend Commentaar        
* Directory Listings 
* Sessie cookies die te lezen zijn in JavaScript.

De volgende zaken zijn geen onderdeel van de workshop:

* Onnodige Http Methods
* BlackBox Scan

## Credits 

Samengesteld en geschreven door Erik Hooijmeijer.

Dank aan Rob Gansevles voor zijn uitgebreide feedback. 
 
Dank aan de deelnemers van de uitprobeer sessies bij 42 B.V. en ESO Gemeente Rotterdam voor hun suggesties, aanvullingen en verbeteringen. 

(c) 2015 E.Hooijmeijer