package com.cheesr.layers.api;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.util.List;
import java.util.concurrent.Callable;

import org.springframework.beans.factory.annotation.Autowired;

import com.cheesr.layers.api.util.Injector;
import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.service.ProductService;

public class ListCheesesCommand implements Callable<List<Cheese>>, Serializable {

    private static final long serialVersionUID = 42L;

    @Autowired
    private transient ProductService productService;

    @Override
    public List<Cheese> call() throws Exception {
        return productService.getAllCheeses();
    }

    private void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
        ois.defaultReadObject();
        Injector.getInstance().inject(this);
    }
}
