package com.cheesr.layers.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import com.cheesr.layers.domain.order.Order;

public class OrderDaoJpa implements OrderDao {

    @PersistenceContext
    private EntityManager em;

    @Override
    public void update(Order order) {
        em.merge(order);
    }

    @Override
    public Order create() {
        Order order = new Order();
        em.persist(order);
        return order;
    }

    @Override
    public Order findById(long id) {
        return em.find(Order.class, id);
    }

    @Override
    public List<Order> findOrders(boolean ordered, boolean fulfilled, boolean cancelled, String name) {
        return em.createQuery(
                "from Order o where o.ordered=" + ordered + " and o.fulfilled=" + fulfilled + " and o.cancelled = " + cancelled
                        + " and o.shippingAddress.name like '%"
                        + name + "%'",
                Order.class).getResultList();
    }
}
