package com.cheesr.layers.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.domain.product.Product;
import com.cheesr.layers.domain.product.Wine;

public class ProductDaoJpa implements ProductDao {

    @PersistenceContext
    private EntityManager em;

    @Override
    public List<Cheese> getAllCheeses() {
        return em.createQuery("from com.cheesr.layers.domain.product.Cheese c where c.id >= 0", Cheese.class).getResultList();
    }

    @Override
    public List<Product> getAllProducts() {
        return em.createQuery("from com.cheesr.layers.domain.product.Product p where p.id >= 0", Product.class).getResultList();
    }

    @Override
    public List<Wine> getAllWines() {
        return em.createQuery("from com.cheesr.layers.domain.product.Wine w where w.id >= 0", Wine.class).getResultList();
    }
    
    @Override
    public Cheese getCheeseById(Long id) {
    	return em.find(Cheese.class, id);
    }
    
    @Override 
    public List<Cheese> findCheeseByName(String name) {
        return em.createQuery("from Cheese c where c.name like '%" + name + "%' and c.id >=0 ", Cheese.class).getResultList();
    }

}
