package com.cheesr.layers.domain.order;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "ADDRESSES")
public class Address {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    @Column(name = "name", length = 42)
    private String name;
    @Column(name = "street", length = 42)
    private String street;
    @Column(name = "zipcode", length = 8)
    private String zipcode;
    @Column(name = "city", length = 42)
    private String city;

    public long getId() {
        return id;
    }

    public String getCity() {
        return city;
    }

    public String getName() {
        return name;
    }

    public String getStreet() {
        return street;
    }

    public String getZipcode() {
        return zipcode;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public void setZipcode(String zipcode) {
        this.zipcode = zipcode;
    }

    public boolean isValid() {
        if (city == null) return false;
        if (name == null) return false;
        if (street == null) return false;
        if (zipcode == null) return false;
        return true;
    }

    @Override
    public boolean equals(Object obj) {
        if ((obj instanceof Address) && (this.id != null)) {
            return ((Address) obj).id.equals(this.id);
        } else {
            return super.equals(obj);
        }
    }

    @Override
    public int hashCode() {
        return (this.id == null ? super.hashCode() : id.intValue());
    }
}
