package com.cheesr.layers.service;

import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.cheesr.layers.domain.order.Order;

@Transactional
public interface OrderService {

    /**
     * @return creates a new, empty, order.
     */
    Order createOrder();

    /**
     * finds the order with the given id.
     * @param id the id.
     * @return the order
     */
    Order findById(Long id);

    /**
     * updates the order in de database.
     * @param order the order.
     */
    void updateOrder(Order order);

    /**
     * checks the order for completeness and executes it.
     * @param order the order.
     */
    void checkoutOrder(Order order);

	/**
	 * @return orders.
	 */
    public List<Order> findOrders(String name);

    /**
     * fulfills the order.
     * @param order the order.
     */
    void fulfillOrder(Order order);

    /**
     * cancels the order.
     * @param order the order.
     */
    void cancelOrder(Order order);

}
