package com.cheesr.layers.service;

import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.domain.product.Product;
import com.cheesr.layers.domain.product.Wine;

/**
 * provides access to the products of this shop.
 */
@Transactional
public interface ProductService {

    /**
     * @return all products, both wines and cheeses.
     */
    List<Product> getAllProducts();

    /**
     * @return all wines.
     */
    List<Wine> getAllWines();

    /**
     * @return all cheeses.
     */
    List<Cheese> getAllCheeses();

	/**
	 * @param id
	 * @return the cheese.
	 */
	Cheese getCheeseById(Long id);
	
	/**
	 * @param name the name.
	 * @return cheeses with the given name.
	 */
	List<Cheese> findCheeseByName(String name);

}
