package com.cheesr.layers.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;

import com.cheesr.layers.dao.OrderDao;
import com.cheesr.layers.domain.order.Order;
import com.cheesr.layers.service.OrderService;

public class OrderServiceImpl implements OrderService {

    private OrderDao orderDao;

    @Autowired
    public OrderServiceImpl(OrderDao orderDao) {
        this.orderDao = orderDao;
    }

    @Override
    public Order createOrder() {
        return orderDao.create();
    }

    @Override
    public Order findById(Long id) {
        return orderDao.findById(id);
    }

    @Override
    public void updateOrder(Order order) {
        orderDao.update(order);
    }

    @Override
    public void checkoutOrder(Order order) {
        //
        order.checkout();
        //
        orderDao.update(order);
        //
    }
    
    @Override
    public void fulfillOrder(Order order) {
        //
        order.fulfill();
        //
        orderDao.update(order);
        //
    }

    @Override
    public void cancelOrder(Order order) {
        //
        order.cancel();
        //
        orderDao.update(order);
        //
    }

    @Override
    public List<Order> findOrders(String name) {
        return orderDao.findOrders(true, false, false, name);
    }
    
    
}
