package com.cheesr.layers.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;

import com.cheesr.layers.dao.ProductDao;
import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.domain.product.Product;
import com.cheesr.layers.domain.product.Wine;
import com.cheesr.layers.service.ProductService;

public class ProductServiceImpl implements ProductService {

    private ProductDao dao;

    @Autowired
    public ProductServiceImpl(ProductDao dao) {
        this.dao = dao;
    }

    @Override
    public List<Cheese> getAllCheeses() {
        return dao.getAllCheeses();
    }

    @Override
    public Cheese getCheeseById(Long id) {
    	return dao.getCheeseById(id);
    }
    
    @Override
    public List<Product> getAllProducts() {
        return dao.getAllProducts();
    }

    @Override
    public List<Wine> getAllWines() {
        return dao.getAllWines();
    }
    
    @Override
    public List<Cheese> findCheeseByName(String name) {    	
    	return dao.findCheeseByName(name);
    }
    
}
