package com.cheesr.layers.web;

import org.apache.wicket.Request;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WebSession;

/**
 * Each user of the BadCheesrApplication is given their own instance of CheesrSession that holds their
 * personal state, such as their shopping cart. This is how multiple users can be using the system
 * at the same time and not have their information mixed up.
 */
public class BadCheesrSession extends WebSession {

    private Long orderId;

    public BadCheesrSession(WebApplication application, Request request) {
        super(request);
    }

    public Long getOrderId() {
        return orderId;
    }

    public void setOrderId(Long orderId) {
        this.orderId = orderId;
    }

}
