package com.cheesr.layers.web;

import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.wicket.util.io.IOUtils;

public class DownloadServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String id = req.getParameter("id");
        try {
            InputStream input = DownloadServlet.class.getResourceAsStream("/products/" + id);
            if (input == null) {
                resp.sendError(404);
            } else {
                try {
                    byte[] data = IOUtils.toByteArray(input);
                    resp.setContentType("application/pdf");
                    resp.setContentLength(data.length);
                    resp.getOutputStream().write(data);
                } finally {
                    input.close();
                }
            }
        } catch (IOException ex) {
            resp.sendError(500);
        }
    }

}
