package com.cheesr.layers.web;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLDecoder;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.wicket.util.io.IOUtils;
import org.slf4j.LoggerFactory;

public class ZapFinancialsIntegrationServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String path = req.getQueryString();
        // prevent path traversal.
        if (path != null && !path.contains("..")) {
            InputStream input = new FileInputStream(new File("./ftp-folder/" + URLDecoder.decode(path, "UTF-8")));
            try {
                byte[] data = IOUtils.toByteArray(input);
                resp.setContentType("text/plain");
                resp.setContentLength(data.length);
                resp.getOutputStream().write(data);
            } finally {
                input.close();
            }
        } else {
            LoggerFactory.getLogger(BadCheesrApplication.class).info(String.format("Path traversal detected '%s'", req.getQueryString()));
            resp.sendError(HttpServletResponse.SC_FORBIDDEN);
        }
    }

}
