package com.cheesr.layers.web.model;

import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.apache.wicket.injection.web.InjectorHolder;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.spring.injection.annot.SpringBean;

import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.service.ProductService;

public class CheeseListModel extends LoadableDetachableModel<List<Cheese>> {

    @SpringBean(name = "productService")
    private ProductService service;
	private Model<String> search;

	public CheeseListModel() {
		this(new Model<String>(""));
	}
	
    public CheeseListModel(Model<String> search) {
		this.search = search;
		InjectorHolder.getInjector().inject(this);
    }

    @Override
    protected List<Cheese> load() {
    	if (StringUtils.isEmpty(search.getObject())) {
            return service.getAllCheeses();
    	}
    	return service.findCheeseByName(search.getObject());
    }

}
