package com.cheesr.layers.web.model;

import org.apache.wicket.injection.web.InjectorHolder;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.spring.injection.annot.SpringBean;

import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.service.ProductService;

/**
 * @author Erik
 *
 */
public class CheeseModel extends LoadableDetachableModel<Cheese> {

	private Long id;

    @SpringBean(name = "productService")
    private ProductService dao;

    public CheeseModel() {
        InjectorHolder.getInjector().inject(this);
    }
	
	public CheeseModel(Long id) {
		this();
		this.id=id;
	}
	
	@Override
	protected Cheese load() {
		return dao.getCheeseById(id);
	}
	
}
