package com.cheesr.layers.web.model;

import java.util.List;

import org.apache.wicket.injection.web.InjectorHolder;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.spring.injection.annot.SpringBean;

import com.cheesr.layers.domain.order.Order;
import com.cheesr.layers.service.OrderService;

/**
 * @author Erik
 *
 */
public class OrderListModel extends LoadableDetachableModel<List<Order>> {

    @SpringBean(name = "orderService")
    private OrderService dao;
	private Model<String> search;

    public OrderListModel(Model<String> search) {
		this.search = search;
		InjectorHolder.getInjector().inject(this);
    }

    @Override
    protected List<Order> load() {
        return dao.findOrders(search.getObject());
    }
	
}
