package com.cheesr.layers.web.model;

import org.apache.wicket.injection.web.InjectorHolder;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.spring.injection.annot.SpringBean;

import com.cheesr.layers.domain.order.Order;
import com.cheesr.layers.service.OrderService;

public class OrderModel extends LoadableDetachableModel<Order> {

    @SpringBean(name = "orderService")
    private OrderService dao;

    private Long orderId;

    public OrderModel(long id) {
        InjectorHolder.getInjector().inject(this);
        orderId = id;
    }

    public OrderModel(Order order) {
        super(order);
        InjectorHolder.getInjector().inject(this);
        this.orderId = order.getId();
    }

    @Override
    protected Order load() {
        if (orderId != null) {
            return dao.findById(orderId);
        } 
        throw new RuntimeException("Cannot load an Order with a null Id.");        
    }

    @Override
    protected void onDetach() {
    }

}
