package com.cheesr.layers.web.validators;

import java.util.regex.Pattern;

import org.apache.wicket.validation.IValidatable;
import org.apache.wicket.validation.IValidator;
import org.apache.wicket.validation.ValidationError;

public class EmailValidator implements IValidator<String> {

    private Pattern pattern;

    public EmailValidator() {
        pattern = Pattern.compile("^([a-zA-Z0-9])(([\\-.]|[_]+)?([a-zA-Z0-9]+))*(@){1}[a-z0-9]+[.]{1}(([a-z]{2,3})|([a-z]{2,3}[.]{1}[a-z]{2,3}))$");
    }

    @Override
    public void validate(IValidatable<String> src) {
        if (!pattern.matcher(src.getValue()).matches()) {
            ValidationError error = new ValidationError();
            error.addMessageKey(getClass().getSimpleName() + ".no.email");
            src.error(error);
        }
    }

}
