package com.cheesr.layers.api;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.concurrent.Callable;

import com.cheesr.layers.domain.product.Cheese;

public class ApiTestClient {

    private String host;

    public ApiTestClient(String host) {
        this.host = host;

    }

    private <A> A call(Callable<A> cmd) throws Exception {
        Socket s = new Socket(host, RemoteApiServer.PORT);
        try {
            ObjectOutputStream out = new ObjectOutputStream(s.getOutputStream());
            out.writeObject(cmd);
            out.flush();
            ObjectInputStream in = new ObjectInputStream(s.getInputStream());
            Object a = in.readObject();
            if (a instanceof RuntimeException) {
                throw (RuntimeException) a;
            }
            return (A) a;
        } finally {
            s.close();
        }
    }

    public static void main(String[] args) throws Exception {
        ListCheesesCommand cmd = new ListCheesesCommand();
        for (Cheese c : new ApiTestClient("localhost").call(cmd)) {
            System.out.println(c.getName());
        }
    }
}
