package com.cheesr.layers.service;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import java.util.List;

import junit.framework.Assert;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import com.cheesr.layers.AbstractSpringContextTestCase;
import com.cheesr.layers.domain.product.Cheese;
import com.cheesr.layers.domain.product.Product;
import com.cheesr.layers.domain.product.Wine;

/**
 * Test case for {@link PostDao}.
 */
public class ProductServiceImplTest extends AbstractSpringContextTestCase {

    /**
     * Post service instance being tested
     */
    @Autowired
    private ProductService productService;

    /**
     * Assert that a product service bean is correctly defined in the context.
     */
    @Test
    public void testContext() throws Exception {
        Assert.assertNotNull(productService);
    }

    @Test
    public void shouldGetAllProducts() {
        List<Product> p = productService.getAllProducts();
        assertNotNull(p);
        assertTrue(p.size() > 0);
    }

    @Test
    public void shouldGetAllCheeses() {
        List<Cheese> p = productService.getAllCheeses();
        assertNotNull(p);
        assertTrue(p.size() > 0);
    }

    @Test
    public void shouldGetAllWine() {
        List<Wine> p = productService.getAllWines();
        assertNotNull(p);
        assertTrue(p.size() > 0);
    }

}
