package com.cheesr.layers.web;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 * Test case for {@link WicketApplication}.
 */
public class BadCheesrApplicationTest {

    private BadCheesrApplication application;

    @Before
    public void setUpApplication() {
        application = new BadCheesrApplication();
    }

    /**
     * Assert that calling {@link WicketApplication#setConfigurationType(String)} changes
     * the configuration type, and can be correctly retrieved using the getter.
     */
    @Test
    public void testGetSetContextType() {
        final String configurationType = "deployment";
        application.setConfigurationType(configurationType);
        Assert.assertEquals(configurationType, application.getConfigurationType());
    }

    /**
     * Assert that calling {@link WicketApplication#getConfigurationType()} while it has
     * not yet been set, throws a {@link IllegalStateException}.
     */
    @Test(expected = IllegalStateException.class)
    public void testGetContextTypeNull() {
        application.getConfigurationType();
    }

}
